/*
 * This file is part of Advanced ABX
 *
 * Copyright 2010 Christian Uebber
 *
 * Advanced ABX is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2, as
 * published by the Free Software Foundation.
 *
 * Advanced ABX is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Advanced ABX.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * OutInFader.java
 *
 *  This file is part of the NilPop package.
 */
package de.uebber.sound.lib;

import org.junit.Test;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Test class for OutInFader
 *
 * @author Christian Uebber
 */
public class OutInFaderTest {

    public OutInFaderTest() {
        Logger.getLogger("lib.OutInFader").setLevel(Level.ALL);
        Logger.getLogger("").getHandlers()[0].setLevel(Level.ALL);
    }

    @Test
    public void testProcess() throws Exception {
        AudioInputStream s1 = AudioSystem.getAudioInputStream(this.getClass().getResource("48000-32-mono-sine.wav"));
        System.out.println("Stream 1: " + s1.getFormat());
        System.out.println(s1.getFrameLength() * s1.getFormat().getFrameSize() * s1.getFormat().getChannels() + " bytes");
        AudioInputStream s2 = AudioSystem.getAudioInputStream(this.getClass().getResource("48000-32-mono-sine.wav"));
        System.out.println("Stream 2: " + s2.getFormat());
        System.out.println(s1.getFrameLength() * s2.getFormat().getFrameSize() * s2.getFormat().getChannels() + " bytes");
        byte[] last = new byte[(int) (s1.getFrameLength() * s1.getFormat().getFrameSize())];
        byte[] next = new byte[last.length];
        byte[] result = new byte[last.length];

        s1.read(last);
        s2.read(next);

        Transitioner transitioner = new OutInFader();

        transitioner.process(last, next, 0, result, 0, 100, s1.getFormat());

//        AudioSystem.write(new AudioInputStream(new ByteArrayInputStream(result), s1.getFormat(), result.length), AudioFileFormat.Type.WAVE, new File("result.wav"));

    }
}
